<script setup>
import jwt_decode from "jwt-decode";

// Récupération des droits :
const tokenCookie = useCookie("aei-desktop-token");
const decodedToken = jwt_decode(tokenCookie.value);
const currentUserId = decodedToken.userId;

const props = defineProps(["selectedInterventionId"]);

const { baseURL } = useRuntimeConfig().app;
const authorizationHeader = useAuthorizationHeader("application/json");
const { data: intervention } = await useFetch(
  baseURL + "api/interventions/" + props.selectedInterventionId,
  {
    headers: authorizationHeader,
  }
);

const getInitials = (agent) => {
  const firstnameInitial = agent.firstname.charAt(0).toUpperCase();
  const lastnameInitial = agent.lastname.charAt(0).toUpperCase();
  return `${firstnameInitial}${lastnameInitial}`;
};

let photosApres = [];
let photosAvant = [];

for (const picture of intervention.value.pictures) {
  if (picture.tags && picture.tags.length > 0) {
    const hasApresTag = picture.tags.some((tag) => tag.name === "Après");
    const hasAvantTag = picture.tags.some((tag) => tag.name === "Avant");

    if (hasApresTag) {
      photosApres.push(picture);
    } else if (hasAvantTag) {
      photosAvant.push(picture);
    }
  }
}

const photosInDesiredOrder = [...(photosApres || []), ...(photosAvant || [])];

// Transformation Date en iso
const currentDate = ref(null);
const date = new Date();
currentDate.value = date.toISOString();

const comments = ref([]);

const commentaireContent = ref("");

async function submitForm() {
  try {
    if (commentaireContent.value) {
      const comment = ref({
        message: commentaireContent.value,
        createdAt: currentDate.value,
        author: `/users/${currentUserId}`,
        intervention: `/interventions/${props.selectedInterventionId}`,
      });

      await $fetch(baseURL + "api/comments", {
        method: "POST",
        headers: authorizationHeader,
        body: JSON.stringify(comment.value),
      });
      console.log("Le com a bien été envoyé");

      comments.value.push(comment.value);

      commentaireContent.value = "";
    }
  } catch (error) {
    console.error(error);
    alert("Une erreur est survenue lors de l'envoi du formulaire.");
  }
}
</script>
<template>
  <div class="participants-container fr-grid-row fr-grid-row--middle fr-p-2w">
    <div class="fr-grid-row avatar-container">
      <div class="agent-avatar" v-for="agent in intervention.participants">
        <img
          v-if="agent.picture"
          :src="agent.picture"
          class="agent-photo"
          :alt="`Photo de ${agent.firstname} ${agent.lastname}`"
        />
        <div v-else class="agent-initials">
          {{ getInitials(agent) }}
        </div>
      </div>
    </div>

    <div class="participants-name fr-ml-3w">
      <p
        class="fr-pt-1v"
        v-for="(agent, index) in intervention.participants"
        :key="index"
      >
        {{ agent.firstname }} {{ agent.lastname
        }}{{ index < intervention.participants.length - 1 ? ", &nbsp;" : "" }}
      </p>
    </div>
  </div>

  <article class="fr-p-2w">
    <div v-if="photosInDesiredOrder.length > 1" class="scrollable-container">
      <ul class="scrollable-list">
        <li v-for="picture in photosInDesiredOrder" :key="picture.id">
          <p class="fr-tag tags-images" v-if="picture.tags.length > 0">
            {{ picture.tags[0].name }}
          </p>
          <img
            class="fr-responsive-img fr-mr-2w"
            :src="picture.URL"
            :alt="`${picture.tags[0].name} intervention`"
          />
        </li>
      </ul>
    </div>
    <div
      class="fr-grid-row fr-grid-row--center"
      v-else-if="intervention.pictures.length === 1"
    >
      <img
        class="fr-mb-2w"
        :src="intervention.pictures[0].URL"
        :alt="`image ${intervention.pictures[0].tags[0].name} intervention`"
        width="380"
        height="380"
      />
    </div>
    <div class="fr-grid-row fr-grid-row--center" v-else>
      <img
        :src="`${intervention.type.picture}`"
        :alt="`${intervention.type.picture}`"
        class="fr-mb-2w"
        width="380"
        height="380"
      />
    </div>
    <div class="fr-grid-row fr-grid-row--middle fr-mt-2w">
      <h2 class="fr-col-9">{{ intervention.type.name }}</h2>
      <button
        :class="['fr-tag', { urgent: intervention.priority.slug === 'urgent' }]"
      >
        {{ intervention.priority.name }}
      </button>
    </div>

    <p class="fr-pt-2w fr-m-0">
      <span class="fr-icon-map-pin-2-line fr-pr-1v"></span
      >{{ intervention.location.rest }} {{ intervention.location.street }}
      {{ intervention.location.postcode }} {{ intervention.location.city }}
    </p>
    <p class="fr-pt-2w fr-m-0">
      <span class="fr-icon-calendar-2-line fr-pr-1w"></span>Publiée
      {{ useFormatDate(intervention.createdAt) }} par
      {{ intervention.author.firstname }}
      {{ intervention.author.lastname }}
    </p>
    <p class="fr-pt-2w fr-m-0">
      <span class="fr-icon-draft-line fr-pr-1w"></span
      >{{ intervention.category.name }}
    </p>
    <slot name="réalisée" />
    <p class="fr-pt-2w fr-my-3w fr-m-0">{{ intervention.description }}</p>
    <slot />

    <slot name="carte" />
  </article>
  <hr />
  <h2 class="fr-px-2w">Commentaires</h2>
  <section class="fr-p-2w">
    <section v-if="intervention.comments.length >= 1 || comments.length >= 1">
      <!--       <div class="fr-hr-or fr-py-2w">
        <h3 class="fr-px-2v">Aujourd'hui</h3>
      </div> -->
      <ul v-if="intervention.comments.length >= 1">
        <li v-for="c in intervention.comments">
          <div v-if="c.author.id === currentUserId">
            <div
              class="fr-responsive-img fr-col-12 fr-mb-1w fr-grid-row fr-grid-row--middle comment-agent"
            >
              <img
                class="fr-p-1w img-comment"
                src="https://cdn.pixabay.com/photo/2015/07/20/13/01/man-852770_960_720.jpg"
                alt=""
              />
              <div>
                <p class="fr-p-2w fr-mb-1w">{{ c.message }}</p>
                <time
                  class="fr-grid-row fr-grid-row--right"
                  :datetime="`${useFormatDate(c.createdAt)}`"
                  >{{ useFormatDate(c.createdAt) }}</time
                >
              </div>
            </div>
          </div>
          <div v-else>
            <div
              class="fr-responsive-img fr-col-12 fr-mb-1w fr-grid-row fr-grid-row--middle comment-externe"
            >
              <img
                class="fr-p-1w img-comment"
                src="https://cdn.pixabay.com/photo/2022/06/25/01/46/woman-7282714_960_720.png"
                alt=""
              />
              <div>
                <p class="fr-p-2w fr-mb-1w">{{ c.message }}</p>
                <time :datetime="`${useFormatDate(c.createdAt)}`">{{
                  useFormatDate(c.createdAt)
                }}</time>
              </div>
            </div>
          </div>
        </li>
      </ul>
    </section>
    <aside v-if="intervention.comments.length === 0 && comments.length === 0">
      Aucun commentaire pour le moment
    </aside>
    <ul v-else>
      <li v-for="c in comments">
        <div
          class="fr-responsive-img fr-col-12 fr-mb-1w fr-grid-row fr-grid-row--middle comment-agent"
        >
          <img
            class="fr-p-1w img-comment"
            src="https://cdn.pixabay.com/photo/2015/07/20/13/01/man-852770_960_720.jpg"
            alt=""
          />
          <div>
            <p class="fr-p-2w fr-mb-1w">{{ c.message }}</p>
            <time
              class="fr-grid-row fr-grid-row--right"
              :datetime="`${useFormatDate(c.createdAt)}`"
              >{{ useFormatDate(c.createdAt) }}</time
            >
          </div>
        </div>
      </li>
    </ul>

    <form class="fr-p-2w comment" @submit.prevent="submitForm">
      <textarea
        class="fr-col-12 fr-p-1w fr-pr-6w"
        placeholder="Ecrire un message"
        v-model="commentaireContent"
      />
      <button
        class="fr-icon-send-plane-fill comment-button"
        type="submit"
      ></button>
    </form>
  </section>
</template>

<style scoped>
.agent-initials {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 38px;
  height: 38px;
  line-height: 38px;
  text-align: center;
  font-weight: bold;
  font-size: 16px;
  background-color: var(--blue-france-925-125);
  color: var(--blue-france-sun-113-625);
  border-radius: 50%;
  border: 1px solid var(--background-default-grey);
}
.agent-avatar {
  position: relative;
  width: 38px;
  height: 38px;
  margin-right: -12px;
}

.agent-photo {
  position: absolute;
  top: 0;
  left: 0;
  width: 38px;
  height: 38px;
  border-radius: 50%;
  border: 1px solid var(--background-default-grey);
}

.participants-container {
  display: flex;
  flex-wrap: nowrap;
  flex-direction: row;
  background-color: #f6f6f6;
}

.avatar-container {
  display: flex;
  flex-wrap: wrap;
}

.participants-name {
  display: flex;
  flex-wrap: wrap; 
  white-space: nowrap;
  overflow: hidden; 
}

.scrollable-container {
  width: 100%;
  overflow-x: auto;
}

.scrollable-list {
  white-space: nowrap;
}

.scrollable-list li {
  display: inline-block;
  vertical-align: top;
}

.scrollable-list img {
  width: 237px;
  height: 237px;
}

li {
  list-style: none;
  position: relative;
}

p.tags-images {
  position: absolute;
  top: 0.5rem;
  left: 0.5rem;
  z-index: 0;
}

h2 {
  font-size: 1.25rem;
}
.urgent {
  background-color: var(--background-action-high-warning);
  color: var(--text-inverted-blue-france);
}

/* COMMENTAIRES */

.img-comment {
  max-width: 4.688rem;
  max-height: 4.688rem;
  border-radius: 100%;
}

div.comment-agent {
  flex-direction: row-reverse;
  flex-wrap: nowrap;
}

div.comment-agent p {
  background-color: var(--background-alt-blue-france);
  border-radius: 1rem 1rem 0rem 1rem;
}

div.comment-externe {
  flex-wrap: nowrap;
}

div.comment-externe div {
  flex-direction: column;
  align-items: flex-end;
}

div.comment-externe p {
  box-shadow: 0 0 0 0.063rem var(--border-default-grey);
  border-radius: 1rem 1rem 1rem 0rem;
}
aside {
  font-style: italic;
  font-weight: 400;
  font-size: 16px;
  line-height: 24px;
}

textarea {
  box-shadow: 0 0 0 0.063rem var(--border-default-grey);
  border-radius: 0.625rem;
  height: 6.25rem;
}

button.comment-button {
  color: var(--background-active-blue-france);
  position: absolute;
  right: 1.5rem;
  top: 1.875rem;
}

h3 {
  background-color: var(--border-default-grey);
  border-radius: 0.625rem;
  font-weight: initial;
  text-transform: none;
}

form {
  position: relative;
}

time {
  font-size: 0.875rem;
}
</style>
